FUNCTION ExeName AS STRING
    LOCAL zTmp AS ASCIIZ * %MAX_PATH, ex AS STRING
    LOCAL LenExeName AS LONG
    STATIC exeN AS STRING

    IF LEN(exeN) < 1 THEN
        LenExeName = GetModuleFileName(0???, zTmp, %MAX_PATH)
        IF LenExeName THEN
           LenExeName = MIN&(LenExeName, %MAX_PATH)
           ex = LEFT$(zTmp, LenExeName)
           exeN = RIGHT$(ex, INSTR(-1, ex, "\") + 1)
        END IF
    END IF
    FUNCTION = exeN
END FUNCTION

FUNCTION ExePath AS STRING
    LOCAL zTmp AS ASCIIZ * %MAX_PATH, ex AS STRING
    LOCAL LenExeName AS LONG
    STATIC exeP AS STRING

    IF LEN(exeP) < 1 THEN
        LenExeName = GetModuleFileName(0???, zTmp, SIZEOF(zTmp))
        IF LenExeName THEN
           LenExeName = MIN&(LenExeName, SIZEOF(zTmp))
           ex = LEFT$(zTmp, LenExeName)
           exeP = LEFT$(ex, INSTR(-1, ex, "\"))
        END IF
    END IF
    FUNCTION = exeP
END FUNCTION
