' EEShell 1.1.2 - the shutdown module
' based on VB version from EEShell2 (found somewhere on the www, can't remember where)
' copyright 2004-2006 Erik Siers
' source available under terms of the GNU GPL version 3

' apparently working OK, but not yet tested on a non-NT system

FUNCTION EnableShutDown () AS LONG
    ' Set the shut down privilege for the current application
    LOCAL hToken AS DWORD
    LOCAL tokenProcess AS TOKEN_PRIVILEGES, PreviousState AS TOKEN_PRIVILEGES

    ' Get the privilege token for this process.
    IF ISFALSE OpenProcessToken(GetCurrentProcess(), %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_QUERY, hToken) THEN EXIT FUNCTION

    ' Get the value of the shutdown privilege.
    IF LookupPrivilegeValue("", "SeShutdownPrivilege", tokenProcess.Privileges(0).pLuid) THEN
        ' Enable the shutdown privilege for this process.
        tokenProcess.PrivilegeCount = 1
        tokenProcess.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
        FUNCTION = AdjustTokenPrivileges(hToken, 0, tokenProcess, 0, PreviousState, 0)
    END IF

    CloseHandle hToken
END FUNCTION

FUNCTION quitWindows (which AS LONG) AS LONG
    REGISTER n AS LONG

    IF IsWinNT THEN
        IF ISFALSE(EnableShutDown) THEN
            MSGBOX "Can't get shutdown privileges, not shutting down."
            EXIT FUNCTION
        END IF
    END IF
    ' logging errors ignored here
    n = appLog ("ExitWindowsEx code " & STR$(which), FUNCNAME$)
    FUNCTION = ExitWindowsEx (which OR %EWX_FORCEIFHUNG, &HFFFF)
END FUNCTION

FUNCTION Standby () AS LONG
    IF IsWinNT THEN
        IF ISFALSE(EnableShutDown) THEN
            MSGBOX "Can't get shutdown privileges, not standing by."
            EXIT FUNCTION
        END IF
    END IF
    applog "Standing by", FUNCNAME$
    SetSystemPowerState ISTRUE(1 = 1), ISTRUE(1 = 0)
END FUNCTION
