' trimmed way the hell down for EEShell
' the standard Win32API.inc will also work but will increase the final .exe size by 3.5 KB

%WINAPI = 1

%WM_USER = &H400
%MAX_PATH  = 260  ' max. length of full pathname

%SE_PRIVILEGE_ENABLED_BY_DEFAULT = &H00000001
%SE_PRIVILEGE_ENABLED = &H00000002
%SE_PRIVILEGE_USED_FOR_ACCESS = &H80000000

%HWND_DESKTOP   = 0

' Token Specific Access Rights.
%TOKEN_ASSIGN_PRIMARY = &H0001
%TOKEN_DUPLICATE = &H0002
%TOKEN_IMPERSONATE = &H0004
%TOKEN_QUERY = &H0008
%TOKEN_QUERY_SOURCE = &H0010
%TOKEN_ADJUST_PRIVILEGES = &H0020
%TOKEN_ADJUST_GROUPS = &H0040
%TOKEN_ADJUST_DEFAULT = &H0080
%TOKEN_ADJUST_SESSIONID = &H0100

' The following are masks for the predefined standard access types
%DELETE = &H00010000
%READ_CONTROL = &H00020000
%WRITE_DAC = &H00040000
%WRITE_OWNER = &H00080000
%SYNCHRONIZE = &H00100000
%STANDARD_RIGHTS_REQUIRED = &H000F0000
%STANDARD_RIGHTS_READ = %READ_CONTROL
%STANDARD_RIGHTS_WRITE = %READ_CONTROL
%STANDARD_RIGHTS_EXECUTE = %READ_CONTROL
%STANDARD_RIGHTS_ALL = &H001F0000
%SPECIFIC_RIGHTS_ALL = &H0000FFFF

%TOKEN_ALL_ACCESS = %STANDARD_RIGHTS_REQUIRED OR %TOKEN_ASSIGN_PRIMARY OR %TOKEN_DUPLICATE OR %TOKEN_IMPERSONATE OR _
                    %TOKEN_QUERY OR %TOKEN_QUERY_SOURCE OR %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_ADJUST_GROUPS OR _
                    %TOKEN_ADJUST_SESSIONID OR %TOKEN_ADJUST_DEFAULT
%TOKEN_READ = %STANDARD_RIGHTS_READ OR %TOKEN_QUERY
%TOKEN_WRITE = %STANDARD_RIGHTS_WRITE OR %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_ADJUST_GROUPS OR %TOKEN_ADJUST_DEFAULT
%TOKEN_EXECUTE = %STANDARD_RIGHTS_EXECUTE

' Token Types / enumerated type TOKEN_TYPE
%TokenPrimary = 1
%TokenImpersonation = 2

' Token Information Classes. / enumerated type TOKEN_INFORMATION_CLASS

%TokenUser = 1
%TokenGroups = 2
%TokenPrivileges = 3
%TokenOwner = 4
%TokenPrimaryGroup = 5
%TokenDefaultDacl = 6
%TokenSource = 7
%TokenType = 8
%TokenImpersonationLevel = 9
%TokenStatistics = 10
%TokenRestrictedSids = 11
%TokenSessionId = 12

%TOKEN_SOURCE_LENGTH = 8

' File attributes
%Normal = &B000000
%ReadOnly = &B000001
%Hidden = &B000010
%System = &B000100
%vLabel = &B001000
%SubDir = &B010000
%Archive = &B100000

'Common RGB Colors
%BLACK = &H000000???
%BLUE= &HFF0000???
%GREEN = &H00FF00???
%CYAN= &HFFFF00???
%RED = &H0000FF???
%MAGENTA = &HFF00FF???
%YELLOW = &H00FFFF???
%WHITE = &HFFFFFF???
%GRAY= &H808080???
%LTGRAY = &HC0C0C0???

' WM_KEYUP/DOWN/CHAR HIWORD(lParam) flags
%KF_EXTENDED = &H00000100
%KF_DLGMODE = &H00000800
%KF_MENUMODE = &H00001000
%KF_ALTDOWN = &H00002000
%KF_REPEAT = &H00004000
%KF_UP = &H00008000

#IF NOT %DEF(%NOVIRTUALKEYCODES)
' Virtual Keys, Standard Set
%VK_LBUTTON = &H01
%VK_RBUTTON = &H02
%VK_CANCEL = &H03
%VK_MBUTTON = &H04 ' NOT contiguous with L RBUTTON
%VK_XBUTTON1 = &H05 ' NOT contiguous with L & RBUTTON
%VK_XBUTTON2 = &H06 ' NOT contiguous with L & RBUTTON
%VK_BACK = &H08
%VK_TAB = &H09
%VK_LINEFEED = &H0A
%VK_CLEAR = &H0C
%VK_RETURN = &H0D
%VK_SHIFT = &H10
%VK_CONTROL = &H11
%VK_MENU = &H12
%VK_PAUSE = &H13
%VK_CAPITAL = &H14
%VK_KANA = &H15
%VK_HANGEUL = &H15 ' old name - should be here for compatibility
%VK_HANGUL = &H15
%VK_JUNJA = &H17
%VK_FINAL = &H18
%VK_HANJA = &H19
%VK_KANJI = &H19
%VK_ESCAPE = &H1B
%VK_CONVERT = &H1C
%VK_NONCONVERT = &H1D
%VK_ACCEPT = &H1E
%VK_MODECHANGE = &H1F
%VK_SPACE = &H20
%VK_PGUP = &H21
%VK_PRIOR = &H21
%VK_NEXT = &H22
%VK_PGDN = &H22
%VK_END = &H23
%VK_HOME = &H24
%VK_LEFT = &H25
%VK_UP = &H26
%VK_RIGHT = &H27
%VK_DOWN = &H28
%VK_SELECT = &H29
%VK_PRINT = &H2A
%VK_EXECUTE = &H2B
%VK_SNAPSHOT = &H2C
%VK_INSERT = &H2D
%VK_DELETE = &H2E
%VK_HELP = &H2F
%VK_0 = &H30
%VK_1 = &H31
%VK_2 = &H32
%VK_3 = &H33
%VK_4 = &H34
%VK_5 = &H35
%VK_6 = &H36
%VK_7 = &H37
%VK_8 = &H38
%VK_9 = &H39
%VK_A = &H41
%VK_B = &H42
%VK_C = &H43
%VK_D = &H44
%VK_E = &H45
%VK_F = &H46
%VK_G = &H47
%VK_H = &H48
%VK_I = &H49
%VK_J = &H4A
%VK_K = &H4B
%VK_L = &H4C
%VK_M = &H4D
%VK_N = &H4E
%VK_O = &H4F
%VK_P = &H50
%VK_Q = &H51
%VK_R = &H52
%VK_S = &H53
%VK_T = &H54
%VK_U = &H55
%VK_V = &H56
%VK_W = &H57
%VK_X = &H58
%VK_Y = &H59
%VK_Z = &H5A
%VK_LWIN = &H5B
%VK_RWIN = &H5C
%VK_APPS = &H5D
%VK_SLEEP = &H5F
%VK_NUMPAD0 = &H60
%VK_NUMPAD1 = &H61
%VK_NUMPAD2 = &H62
%VK_NUMPAD3 = &H63
%VK_NUMPAD4 = &H64
%VK_NUMPAD5 = &H65
%VK_NUMPAD6 = &H66
%VK_NUMPAD7 = &H67
%VK_NUMPAD8 = &H68
%VK_NUMPAD9 = &H69
%VK_MULTIPLY = &H6A
%VK_ADD = &H6B
%VK_SEPARATOR= &H6C
%VK_SUBTRACT = &H6D
%VK_DECIMAL = &H6E
%VK_DIVIDE = &H6F
%VK_F1 = &H70
%VK_F2 = &H71
%VK_F3 = &H72
%VK_F4 = &H73
%VK_F5 = &H74
%VK_F6 = &H75
%VK_F7 = &H76
%VK_F8 = &H77
%VK_F9 = &H78
%VK_F10 = &H79
%VK_F11 = &H7A
%VK_F12 = &H7B
%VK_F13 = &H7C
%VK_F14 = &H7D
%VK_F15 = &H7E
%VK_F16 = &H7F
%VK_F17 = &H80
%VK_F18 = &H81
%VK_F19 = &H82
%VK_F20 = &H83
%VK_F21 = &H84
%VK_F22 = &H85
%VK_F23 = &H86
%VK_F24 = &H87
%VK_NUMLOCK = &H90
%VK_SCROLL = &H91
#ENDIF ' %DEF(%NOVIRTUALKEYCODES)

' wParam for %WM_POWER window message and DRV_POWER driver notification
%PWR_OK = 1
%PWR_FAIL = -1
%PWR_SUSPENDREQUEST = 1
%PWR_SUSPENDRESUME = 2
%PWR_CRITICALRESUME = 3

%WM_COPYDATA = &H4A
%WM_CANCELJOURNAL = &H4B
%WM_NOTIFY = &H4E
%WM_INPUTLANGUAGECHANGEREQUEST = &H50
%WM_INPUTLANGCHANGEREQUEST = &H50
%WM_INPUTLANGUAGECHANGE = &H51
%WM_INPUTLANGCHANGE = &H51
%WM_TCARD = &H52
%WM_HELP = &H53
%WM_USERCHANGED = &H54
%WM_NOTIFYFORMAT = &H55

%WM_CONTEXTMENU = &H07B
%WM_STYLECHANGING = &H07C
%WM_STYLECHANGED = &H07D
%WM_DISPLAYCHANGE = &H07E

%WM_GETICON = &H07F
%WM_SETICON = &H080
%WM_NCCREATE = &H081
%WM_NCDESTROY = &H082
%WM_NCCALCSIZE = &H083
%WM_NCHITTEST = &H084
%WM_NCPAINT = &H085
%WM_NCACTIVATE = &H086
%WM_GETDLGCODE = &H087
%WM_SYNCPAINT = &H088
%WM_NCMOUSEMOVE = &H0A0
%WM_NCLBUTTONDOWN = &H0A1
%WM_NCLBUTTONUP = &H0A2
%WM_NCLBUTTONDBLCLK = &H0A3
%WM_NCRBUTTONDOWN = &H0A4
%WM_NCRBUTTONUP = &H0A5
%WM_NCRBUTTONDBLCLK = &H0A6
%WM_NCMBUTTONDOWN = &H0A7
%WM_NCMBUTTONUP = &H0A8
%WM_NCMBUTTONDBLCLK = &H0A9
%WM_NCXBUTTONDOWN = &H0AB
%WM_NCXBUTTONUP = &H0AC
%WM_NCXBUTTONDBLCLK = &H0AD
%WM_INPUT = &H0FF
%WM_KEYFIRST = &H100
%WM_KEYDOWN = &H100
%WM_KEYUP = &H101
%WM_CHAR = &H102
%WM_DEADCHAR = &H103
%WM_SYSKEYDOWN = &H104
%WM_SYSKEYUP = &H105
%WM_SYSCHAR = &H106
%WM_SYSDEADCHAR = &H107
%WM_UNICHAR = &H0109
%WM_KEYLAST = &H0109
%UNICODE_NOCHAR = &H0FFFF
%WM_INITDIALOG = &H110
%WM_COMMAND = &H111
%WM_SYSCOMMAND = &H112
%WM_TIMER = &H113
%WM_HSCROLL = &H114
%WM_VSCROLL = &H115
%WM_INITMENU = &H116
%WM_INITMENUPOPUP = &H117
%WM_MENUSELECT = &H11F
%WM_MENUCHAR = &H120
%WM_ENTERIDLE = &H121
%WM_MENURBUTTONUP = &H0122
%WM_MENUDRAG = &H0123
%WM_MENUGETOBJECT = &H0124
%WM_UNINITMENUPOPUP = &H0125
%WM_MENUCOMMAND = &H0126
%WM_CHANGEUISTATE = &H0127
%WM_UPDATEUISTATE = &H0128
%WM_QUERYUISTATE = &H0129
%WM_CTLCOLORMSGBOX = &H132
%WM_CTLCOLOREDIT = &H133
%WM_CTLCOLORLISTBOX = &H134
%WM_CTLCOLORBTN = &H135
%WM_CTLCOLORDLG = &H136
%WM_CTLCOLORSCROLLBAR= &H137
%WM_CTLCOLORSTATIC = &H138
%WM_MOUSEFIRST = &H200
%WM_MOUSEMOVE = &H200
%WM_LBUTTONDOWN = &H201
%WM_LBUTTONUP = &H202
%WM_LBUTTONDBLCLK = &H203
%WM_RBUTTONDOWN = &H204
%WM_RBUTTONUP = &H205
%WM_RBUTTONDBLCLK = &H206
%WM_MBUTTONDOWN = &H207
%WM_MBUTTONUP = &H208
%WM_MBUTTONDBLCLK = &H209
%WM_MOUSEWHEEL = &H20A
%WM_XBUTTONDOWN = &H20B
%WM_XBUTTONUP = &H20C
%WM_XBUTTONDBLCLK = &H20D
%WM_MOUSELAST = &H20D
%WM_PARENTNOTIFY = &H210
%WM_ENTERMENULOOP = &H211
%WM_EXITMENULOOP = &H212

%WM_SIZING = &H214
%WM_CAPTURECHANGED = &H215
%WM_MOVING = &H216

%WM_POWERBROADCAST = &H218
%WM_DEVICECHANGE = &H219
%WM_MDICREATE = &H220
%WM_MDIDESTROY = &H221
%WM_MDIACTIVATE = &H222
%WM_MDIRESTORE = &H223
%WM_MDINEXT = &H224
%WM_MDIMAXIMIZE = &H225
%WM_MDITILE = &H226
%WM_MDICASCADE = &H227
%WM_MDIICONARRANGE = &H228
%WM_MDIGETACTIVE = &H229
%WM_MDISETMENU = &H230
%WM_ENTERSIZEMOVE = &H231
%WM_EXITSIZEMOVE = &H232
%WM_DROPFILES = &H233
%WM_MDIREFRESHMENU = &H234

%WM_MOUSEHOVER = &H2A1
%WM_MOUSELEAVE = &H2A3
%WM_WTSSESSION_CHANGE = &H02B1
%WM_TABLET_FIRST = &H02c0
%WM_TABLET_LAST = &H02df

%WM_CUT = &H300
%WM_COPY = &H301
%WM_PASTE = &H302
%WM_CLEAR = &H303
%WM_UNDO = &H304
%WM_RENDERFORMAT = &H305
%WM_RENDERALLFORMATS = &H306
%WM_DESTROYCLIPBOARD = &H307
%WM_DRAWCLIPBOARD = &H308
%WM_PAINTCLIPBOARD = &H309
%WM_VSCROLLCLIPBOARD = &H30A
%WM_SIZECLIPBOARD = &H30B
%WM_ASKCBFORMATNAME = &H30C
%WM_CHANGECBCHAIN = &H30D
%WM_HSCROLLCLIPBOARD = &H30E
%WM_QUERYNEWPALETTE = &H30F
%WM_PALETTEISCHANGING= &H310
%WM_PALETTECHANGED = &H311
%WM_HOTKEY = &H312
%WM_PRINT = &H317
%WM_PRINTCLIENT = &H318
%WM_APPCOMMAND = &H319
%WM_THEMECHANGED = &H31A

%WM_HANDHELDFIRST = &H0358
%WM_HANDHELDLAST = &H035F
%WM_AFXFIRST = &H0360
%WM_AFXLAST = &H037F

%WM_PENWINFIRST = &H380
%WM_PENWINLAST = &H38F

%WM_APP = &H08000

' Window Styles
%WS_OVERLAPPED = &H0
%WS_POPUP = &H80000000
%WS_CHILD = &H40000000
%WS_MINIMIZE = &H20000000
%WS_VISIBLE = &H10000000
%WS_DISABLED = &H08000000
%WS_CLIPSIBLINGS = &H04000000
%WS_CLIPCHILDREN = &H02000000
%WS_MAXIMIZE = &H01000000
%WS_CAPTION = &H00C00000 ' WS_BORDER OR WS_DLGFRAME
%WS_BORDER = &H00800000
%WS_DLGFRAME = &H00400000
%WS_VSCROLL = &H00200000
%WS_HSCROLL = &H00100000
%WS_SYSMENU = &H00080000
%WS_THICKFRAME = &H00040000
%WS_GROUP = &H00020000
%WS_TABSTOP = &H00010000
%WS_MINIMIZEBOX = &H00020000
%WS_MAXIMIZEBOX = &H00010000
%WS_TILED = %WS_OVERLAPPED
%WS_ICONIC = %WS_MINIMIZE
%WS_SIZEBOX = %WS_THICKFRAME
%WS_OVERLAPPEDWIN = %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME
%WS_OVERLAPPEDWINDOW= %WS_OVERLAPPED OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX
%WS_TILEDWINDOW = %WS_OVERLAPPEDWINDOW
%WS_POPUPWINDOW = %WS_POPUP OR %WS_BORDER OR %WS_SYSMENU
%WS_CHILDWINDOW = %WS_CHILD

%WS_EX_DLGMODALFRAME = &H00000001
%WS_EX_NOPARENTNOTIFY = &H00000004
%WS_EX_TOPMOST = &H00000008
%WS_EX_ACCEPTFILES = &H00000010
%WS_EX_TRANSPARENT = &H00000020
%WS_EX_MDICHILD = &H00000040
%WS_EX_TOOLWINDOW = &H00000080
%WS_EX_SMCAPTION = &H00000080
%WS_EX_WINDOWEDGE = &H00000100
%WS_EX_CLIENTEDGE = &H00000200
%WS_EX_CONTEXTHELP = &H00000400
%WS_EX_RIGHT = &H00001000
%WS_EX_LEFT = &H00000000
%WS_EX_RTLREADING = &H00002000
%WS_EX_LTRREADING = &H00000000
%WS_EX_LEFTSCROLLBAR = &H00004000
%WS_EX_RIGHTSCROLLBAR = &H00000000
%WS_EX_CONTROLPARENT = &H00010000
%WS_EX_STATICEDGE = &H00020000
%WS_EX_APPWINDOW = &H00040000
%WS_EX_OVERLAPPEDWINDOW= %WS_EX_WINDOWEDGE OR %WS_EX_CLIENTEDGE
%WS_EX_PALETTEWINDOW = %WS_EX_WINDOWEDGE OR %WS_EX_TOOLWINDOW OR %WS_EX_TOPMOST
%WS_EX_LAYERED = &H00080000
%WS_EX_NOINHERITLAYOUT = &H00100000
%WS_EX_LAYOUTRTL = &H00400000
%WS_EX_COMPOSITED = &H02000000
%WS_EX_NOACTIVATE = &H08000000

%EWX_LOGOFF = &H0000
%EWX_SHUTDOWN = &H0001
%EWX_REBOOT = &H0002
%EWX_FORCE = &H0004
%EWX_POWEROFF = &H0008
%EWX_FORCEIFHUNG = &H0010

' MessageBox() Flags
%MB_OK = &H00000000&
%MB_OKCANCEL = &H00000001&
%MB_ABORTRETRYIGNORE = &H00000002&
%MB_YESNOCANCEL = &H00000003&
%MB_YESNO = &H00000004&
%MB_RETRYCANCEL = &H00000005&
%MB_CANCELTRYCONTINUE = &H00000006&

%MB_ICONHAND = &H00000010&
%MB_ICONQUESTION = &H00000020&
%MB_ICONEXCLAMATION = &H00000030&
%MB_ICONASTERISK = &H00000040&

%MB_USERICON = &H00000080&
%MB_ICONWARNING = %MB_ICONEXCLAMATION
%MB_ICONERROR = %MB_ICONHAND

%MB_ICONINFORMATION = %MB_ICONASTERISK
%MB_ICONSTOP = %MB_ICONHAND

%MB_DEFBUTTON1 = &H00000000&
%MB_DEFBUTTON2 = &H00000100&
%MB_DEFBUTTON3 = &H00000200&
%MB_DEFBUTTON4 = &H00000300&

%MB_APPLMODAL = &H00000000&
%MB_SYSTEMMODAL = &H00001000&
%MB_TASKMODAL = &H00002000&
%MB_HELP = &H00004000& ' Help Button

%MB_NOFOCUS = &H00008000&
%MB_SETFOREGROUND = &H00010000&
%MB_DEFAULT_DESKTOP_ONLY = &H00020000&

%MB_TOPMOST = &H00040000&
%MB_RIGHT = &H00080000&
%MB_RTLREADING = &H00100000&

%MB_SERVICE_NOTIFICATION = &H00200000&
%MB_SERVICE_NOTIFICATION_NT3X = &H00040000&

%MB_TYPEMASK = &H0000000F&
%MB_ICONMASK = &H000000F0&
%MB_DEFMASK = &H00000F00&
%MB_MODEMASK = &H00003000&
%MB_MISCMASK = &H0000C000&

' Standard Icon IDs
%IDI_APPLICATION = 32512
%IDI_HAND = 32513
%IDI_ERROR = %IDI_HAND
%IDI_QUESTION = 32514
%IDI_EXCLAMATION = 32515
%IDI_WARNING = %IDI_EXCLAMATION
%IDI_ASTERISK = 32516
%IDI_INFORMATION = %IDI_ASTERISK
%IDI_WINLOGO = 32517

' Dialog Box Command IDs
%IDOK = 1
%IDCANCEL = 2
%IDABORT = 3
%IDRETRY = 4
%IDIGNORE = 5
%IDYES = 6
%IDNO = 7
%IDCLOSE = 8
%IDHELP = 9
%IDTRYAGAIN = 10
%IDCONTINUE = 11

#IF NOT %DEF(%IDTIMEOUT)
%IDTIMEOUT = 32000
#ENDIF

' Button Control Styles
%BS_TEXT = &H0&
%BS_PUSHBUTTON = &H0&
%BS_DEFPUSHBUTTON = &H1&
%BS_DEFAULT = %BS_DEFPUSHBUTTON
%BS_CHECKBOX = &H2&
%BS_AUTOCHECKBOX = &H3&
%BS_RADIOBUTTON = &H4&
%BS_3STATE = &H5&
%BS_AUTO3STATE = &H6&
%BS_GROUPBOX = &H7&
%BS_USERBUTTON = &H8&
%BS_AUTORADIOBUTTON = &H9&
%BS_OWNERDRAW = &HB&
%BS_LEFTTEXT = &H20&
%BS_ICON = &H40&
%BS_BITMAP = &H80&
%BS_LEFT = &H100&
%BS_RIGHT = &H200&
%BS_CENTER = &H300&
%BS_TOP = &H400&
%BS_BOTTOM = &H800&
%BS_VCENTER = &HC00&
%BS_PUSHLIKE = &H00001000&
%BS_MULTILINE = &H00002000&
%BS_NOTIFY = &H00004000&
%BS_FLAT = &H00008000&
%BS_RIGHTBUTTON = %BS_LEFTTEXT

' User Button Notification Codes
%BN_CLICKED = 0
%BN_PAINT = 1
%BN_HILITE = 2
%BN_UNHILITE = 3
%BN_DISABLE = 4
%BN_DOUBLECLICKED = 5
%BN_SETFOCUS = 6
%BN_KILLFOCUS = 7
%BN_DBLCLK = %BN_DOUBLECLICKED

' Dialog Styles
%DS_ABSALIGN = &H0001&
%DS_SYSMODAL = &H0002&
%DS_3DLOOK = &H0004&
%DS_FIXEDSYS = &H0008&
%DS_NOFAILCREATE = &H0010&
%DS_LOCALEDIT = &H0020& ' Edit items get Local storage.
%DS_SETFONT = &H0040& ' User specified font for Dlg controls
%DS_MODALFRAME = &H0080& ' Can be combined with WS_CAPTION
%DS_NOIDLEMSG = &H0100& ' WM_ENTERIDLE message will not be sent
%DS_SETFOREGROUND = &H0200& ' not in win3.1
%DS_CONTROL = &H0400&
%DS_CENTER = &H0800&
%DS_CENTERMOUSE = &H1000&
%DS_CONTEXTHELP = &H2000&

%DM_GETDEFID = %WM_USER + 0
%DM_SETDEFID = %WM_USER + 1
%DM_REPOSITION = %WM_USER + 2
%DC_HASDEFID = &H534B

' Microsoft docs and structures identify these as WORD values, although
' they obviously aren't defined that way...!
%VER_SERVER_NT = &H80000000
%VER_WORKSTATION_NT = &H40000000
%VER_SUITE_SMALLBUSINESS = &H00000001
%VER_SUITE_ENTERPRISE = &H00000002
%VER_SUITE_BACKOFFICE = &H00000004
%VER_SUITE_COMMUNICATIONS = &H00000008
%VER_SUITE_TERMINAL = &H00000010
%VER_SUITE_SMALLBUSINESS_RESTRICTED = &H00000020
%VER_SUITE_EMBEDDEDNT = &H00000040
%VER_SUITE_DATACENTER = &H00000080
%VER_SUITE_SINGLEUSERTS = &H00000100
%VER_SUITE_PERSONAL = &H00000200
%VER_SUITE_BLADE = &H00000400

' RtlVerifyVersionInfo() conditions

%VER_EQUAL = 1
%VER_GREATER = 2
%VER_GREATER_EQUAL = 3
%VER_LESS = 4
%VER_LESS_EQUAL = 5
%VER_AND = 6
%VER_OR = 7

%VER_CONDITION_MASK = 7
%VER_NUM_BITS_PER_CONDITION_MASK = 3

' RtlVerifyVersionInfo() type mask bits

%VER_MINORVERSION = &H0000001
%VER_MAJORVERSION = &H0000002
%VER_BUILDNUMBER = &H0000004
%VER_PLATFORMID = &H0000008
%VER_SERVICEPACKMINOR = &H0000010
%VER_SERVICEPACKMAJOR = &H0000020
%VER_SUITENAME = &H0000040
%VER_PRODUCT_TYPE = &H0000080

' RtlVerifyVersionInfo() os product type values

%VER_NT_WORKSTATION = &H0000001
%VER_NT_DOMAIN_CONTROLLER = &H0000002
%VER_NT_SERVER = &H0000003

' dwPlatformId defines:

%VER_PLATFORM_WIN32s = 0
%VER_PLATFORM_WIN32_WINDOWS = 1
%VER_PLATFORM_WIN32_NT = 2

TYPE LUID
  LowPart AS DWORD
  HighPart AS LONG
END TYPE

TYPE LUID_AND_ATTRIBUTES
  pLuid AS LUID
  Attributes AS DWORD
END TYPE

TYPE TOKEN_PRIVILEGES
    PrivilegeCount AS DWORD
    Privileges(0 TO 0) AS LUID_AND_ATTRIBUTES  ' array size may vary
END TYPE

TYPE OSVERSIONINFO
    dwOSVersionInfoSize AS DWORD
    dwMajorVersion AS DWORD
    dwMinorVersion AS DWORD
    dwBuildNumber AS DWORD
    dwPlatformId AS DWORD
    szCSDVersion AS ASCIIZ * 128  ' Maintenance string for PSS usage
END TYPE

DECLARE FUNCTION AdjustTokenPrivileges LIB "ADVAPI32.DLL" ALIAS "AdjustTokenPrivileges" (BYVAL TokenHandle AS DWORD, _
        BYVAL DisableAllPrivileges AS LONG, NewState AS ANY, BYVAL BufferLength AS DWORD, PreviousState AS ANY, _
        ReturnLength AS DWORD) AS LONG
DECLARE FUNCTION LookupPrivilegeValue LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeValueA" (lpSystemName AS ASCIIZ, _
        lpName AS ASCIIZ, lpLuid AS LUID) AS LONG
DECLARE FUNCTION OpenProcessToken LIB "ADVAPI32.DLL" ALIAS "OpenProcessToken" (BYVAL ProcessHandle AS DWORD, _
        BYVAL DesiredAccess AS DWORD, TokenHandle AS DWORD) AS LONG

DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION GetCurrentProcess LIB "KERNEL32.DLL" ALIAS "GetCurrentProcess" () AS LONG
DECLARE FUNCTION GetModuleFileName LIB "KERNEL32.DLL" ALIAS "GetModuleFileNameA" (BYVAL hModule AS DWORD, _
        lpFileName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION GetVersionEx LIB "KERNEL32.DLL" ALIAS "GetVersionExA" (lpVersionInformation AS ANY) AS LONG
DECLARE FUNCTION SetSystemPowerState LIB "KERNEL32.DLL" ALIAS "SetSystemPowerState" (BYVAL fSuspend AS LONG, _
        BYVAL fForce AS LONG) AS LONG

DECLARE FUNCTION ShellExecute LIB "SHELL32.DLL" ALIAS "ShellExecuteA" (BYVAL hwnd AS DWORD, lpOperation AS ASCIIZ, _
        lpFile AS ASCIIZ, lpParameters AS ASCIIZ, lpDirectory AS ASCIIZ, BYVAL nShowCmd AS LONG) AS DWORD

DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION ExitWindowsEx LIB "USER32.DLL" ALIAS "ExitWindowsEx" (BYVAL uFlags AS DWORD, BYVAL dwReserved AS DWORD) _
        AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
